'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _reactRedux = require('react-redux');

var _selector = require('./selector');

var _action = require('./action');

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/**
 * Create a higher-order wrapper which provides an array of components to render
 * to its wrapped instance.
 *
 * @param {Object|Function} rawRenderMap An object with component type/render
 * function key value pairs or a function returning such an object.
 * @param {Object} defaultProps An object or a function returing such an
 * object.
 * @returns {Function} Higher-order component wrapper.
 */
exports.default = function () {
  var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var scope = _ref.scope;

  var defaultProps = _objectWithoutProperties(_ref, ['scope']);

  return function (WrappedComponent) {
    var Connect = function (_Component) {
      _inherits(Connect, _Component);

      function Connect() {
        _classCallCheck(this, Connect);

        return _possibleConstructorReturn(this, (Connect.__proto__ || Object.getPrototypeOf(Connect)).apply(this, arguments));
      }

      _createClass(Connect, [{
        key: 'render',
        value: function render() {
          var _props$___relocationS = this.props.___relocationState___;
          var components = _props$___relocationS.components;
          var renderMap = _props$___relocationS.renderMap;
          var _props$___relocationD = this.props.___relocationDispatch___;
          var removeComponent = _props$___relocationD.removeComponent;
          var updateComponent = _props$___relocationD.updateComponent;


          var inRenderMap = function inRenderMap(component) {
            return typeof renderMap[component.type] === 'function';
          };

          var assign = function assign(component) {
            var result = _extends({}, component, {
              render: renderMap[component.type],
              update: function update(props) {
                return updateComponent(component.id, props);
              },
              remove: function remove() {
                return removeComponent(component.id);
              }
            });

            if (scope) {
              result.scope = scope;
            }

            return result;
          };

          var currentComponents = components
          // Remove components not included in the render function map.
          .filter(inRenderMap)
          // Assign render update and remove functions and scope if it is defined.
          .map(assign);

          /* eslint-disable no-unused-vars */
          var _props = this.props;
          var ___relocationState___ = _props.___relocationState___;
          var ___relocationDispatch___ = _props.___relocationDispatch___;

          var childProps = _objectWithoutProperties(_props, ['___relocationState___', '___relocationDispatch___']);
          /* eslint-enable no-unused-vars */

          var mergedProps = _extends({}, childProps, scope ? _defineProperty({}, scope, { components: currentComponents }) : { components: currentComponents });

          return (0, _react.createElement)(WrappedComponent, mergedProps);
        }
      }]);

      return Connect;
    }(_react.Component);

    Connect.propTypes = {
      ___relocationDispatch___: _react.PropTypes.shape({
        removeComponent: _react.PropTypes.func.isRequired
      }),
      ___relocationState___: _react.PropTypes.shape({
        components: _util.componentsShape.isRequired,
        renderMap: _util.renderMapShape.isRequired
      }).isRequired
    };
    Connect.contextTypes = {
      router: _react.PropTypes.object
    };


    Connect.displayName = 'Relocation(' + (0, _util.getDisplayName)(WrappedComponent) + ')';

    var mapState = function mapState(state, props) {
      var mergedProps = _extends({}, defaultProps, scope ? props[scope] : props);

      var components = mergedProps.components;
      var getRelocationState = mergedProps.getRelocationState;


      var selectorProps = getRelocationState ? _extends({ getRelocationState: getRelocationState }, props) : props;

      return {
        // Put everything in a ___relocationState___ namespace to avoid possible
        // conflict with existing props.
        ___relocationState___: {
          components: (0, _selector.getComponents)(state, selectorProps),
          renderMap: components
        }
      };
    };

    var mapDispatch = function mapDispatch(dispatch) {
      return {
        // Put everything in a ___relocationDispatch___ namespace to avoid
        // possible conflict with existing props.
        ___relocationDispatch___: {
          removeComponent: function removeComponent(id) {
            return dispatch((0, _action.removeComponent)(id));
          },
          updateComponent: function updateComponent(id, props) {
            return dispatch((0, _action.updateComponent)(id, props));
          }
        }
      };
    };

    return (0, _reactRedux.connect)(mapState, mapDispatch)((0, _hoistNonReactStatics2.default)(Connect, WrappedComponent));
  };
};
//# sourceMappingURL=connect.js.map